<template>
  <div class="wrapper">
    <table>
      <thead>
        <th>First name</th>
        <th>Last name</th>
        <th>Carrier</th>
        <th class="filter" :class="{ active: showFilter }">
          <div @click="showFilterHandler">
            Status<span class="filter__icon"></span>
          </div>
          <Transition>
            <span class="filter__filtered" v-if="isFiltered"></span>
          </Transition>
          <Transition>
            <div class="dropdown" v-if="showFilter">
              <div
                v-for="item in initialStatuses"
                :key="item"
                class="dropdown__item"
                @click="selectStatusHandler(item)"
              >
                <div :class="{ active: statuses.includes(item) }">
                  <CheckIcon />
                </div>
                <div>{{ item }}</div>
              </div>
            </div>
          </Transition>
        </th>
        <th>Date</th>
      </thead>
      <tbody>
        <tr v-for="item in data" :key="item.id">
          <td>{{ item.firstName }}</td>
          <td>{{ item.lastName }}</td>
          <td>{{ item.carrier }}</td>
          <td>{{ item.status }}</td>
          <td>{{ formatDate(item.eventDate) }}</td>
        </tr>
      </tbody>
    </table>
    <div v-if="isFetching">Loading...</div>
  </div>
</template>

<script>
// import data from "../data/data.json";
import { DateTime } from "luxon";
import CheckIcon from "./icons/Check.vue";
import { fetchData } from "../services/apiService";

const statuses = ["COMPLETE", "ERROR", "INCOMPLETE"];

export default {
  components: { CheckIcon },
  data() {
    return {
      initialData: [],
      data: [],
      showFilter: false,
      initialStatuses: [...statuses],
      statuses: [...statuses],
      isFetching: false,
    };
  },
  computed: {
    isFiltered() {
      return this.statuses.length !== this.initialStatuses.length;
    },
  },
  created() {
    this.fetchTableData();
  },
  methods: {
    async fetchTableData() {
      this.isFetching = true;

      try {
        const data = await fetchData();
        this.initialData = data;
        this.data = data.map((item, index) => ({
          ...item,
          id: index + 1,
        }));
      } catch (e) {
        throw new Error(e);
      }

      this.isFetching = false;
    },
    selectStatusHandler(status) {
      if (this.statuses.includes(status)) {
        this.statuses.splice(this.statuses.indexOf(status), 1);
      } else {
        this.statuses.push(status);
      }

      this.filterByStatus();
    },
    filterByStatus() {
      this.data = this.initialData.filter((item) => {
        return this.statuses.includes(item.status);
      });
    },
    showFilterHandler() {
      this.showFilter = !this.showFilter;
    },
    formatDate(date) {
      return DateTime.fromISO(date).toFormat("MMM. d, y");
    },
  },
};
</script>

<style lang="scss" scoped>
.wrapper {
  padding: 50px;
}
table {
  text-align: left;
  border: 1px solid rgba(#000, 0.2);
  width: 100%;
  margin-bottom: 10px;
}
th,
td {
  padding: 10px;
}
th {
  font-weight: bold;
  border-bottom: 1px solid rgba(#000, 0.2);
}
.filter {
  cursor: pointer;
  position: relative;
  &__icon {
    margin-left: 10px;
    display: inline-block;
    vertical-align: middle;
    border-top: 7px solid var(--color-text);
    border-left: 7px solid transparent;
    border-right: 7px solid transparent;
    transition: transform 0.3s;
  }
  &__filtered {
    display: block;
    width: 8px;
    height: 8px;
    border-radius: 50%;
    background-color: var(--color-blue);
    position: absolute;
    left: 3px;
    top: 8px;
  }
  &.active {
    .filter {
      &__icon {
        transform: rotate(-180deg);
      }
    }
  }
}
.dropdown {
  position: absolute;
  top: 100%;
  left: 0;
  background-color: var(--color-background);
  border: 1px solid rgba(#000, 0.2);
  padding: 5px 0;
  &__item {
    display: flex;
    align-items: center;
    padding: 5px;
    &:hover {
      background-color: rgba(#000, 0.05);
    }
    div {
      &:first-child {
        flex-shrink: 0;
        width: 20px;
        height: 20px;
        margin-right: 5px;
        display: flex;
        align-items: center;
        justify-content: center;
        border: 1px solid var(--color-blue);
        transition: background-color 0.3s;
        &.active {
          background-color: var(--color-blue);
          svg {
            width: 70%;
            height: auto;
            display: block;
            opacity: 1;
            &::v-deep * {
              fill: var(--color-background);
            }
          }
        }
      }
      svg {
        width: 70%;
        height: auto;
        display: block;
        opacity: 0;
      }
    }
  }
}

.v-enter-active,
.v-leave-active {
  transition: opacity 0.3s ease;
}

.v-enter-from,
.v-leave-to {
  opacity: 0;
}
</style>
